#!/usr/local/bin/perl
## rcsbbs.cgi
## Copyright(C) rin (http://rohuu.s59.xrea.com/) 2004-2006
## Last modified 2006/12/25 22:41:22 +09:00
## Main program

#######################################
#   RCS-BOARD Ver-3.0.7 (2006/12/25)
#   Copyright(C) rin (rohuu)
#   http://rohuu.s59.xrea.com/
#######################################

require 5;
#use strict;
#use vars qw(%GLOBAL %INI %in %COOK);

$GLOBAL{'version'} = '3.0.7';
$GLOBAL{'product_name'} = 'RCS-BOARD';

&initial();
&main();

exit(0);


##------------------------------------------
## Initial routine
##------------------------------------------
sub initial{
	$| = 1;
	if(!do './rcsini.cgi'){&debug();}
	if(!do "$INI{'skin_file'}"){&debug();}
	&decode();
	&get_cook();

	## Get browser name and version.
	($GLOBAL{'browser'}, $GLOBAL{'browser_ver'}) = &get_browser();
	my $func_ref = sub{my($a, $b) = @_;  $b =~ s/\.//g;  return "$a.$b";};
	$GLOBAL{'browser_ver'} =~ s/^(\d+)\.([\d\.]+)$/$func_ref->($1, $2)/e;

	## Can use JavaScript Full-Mode?
	if((($GLOBAL{'browser'} eq 'Gecko' && $GLOBAL{'browser_ver'} >= 1) ||
		($GLOBAL{'browser'} eq 'Opera' && $GLOBAL{'browser_ver'} >= 7.5) ||
		($GLOBAL{'browser'} eq 'AppleWebKit' && $GLOBAL{'browser_ver'} >= 0) ||
		($GLOBAL{'browser'} eq 'KHTML' && $GLOBAL{'browser_ver'} >= 2) ||
		($GLOBAL{'browser'} eq 'IE' && $GLOBAL{'browser_ver'} >= 5)) &&
		$INI{'js_full_mode'})
		{$GLOBAL{'js_full_mode'} = 1;}

	## Can use Ajax?
	if((($GLOBAL{'browser'} eq 'Gecko' && $GLOBAL{'browser_ver'} >= 1) ||
		($GLOBAL{'browser'} eq 'Opera' && $GLOBAL{'browser_ver'} >= 8) ||
		($GLOBAL{'browser'} eq 'AppleWebKit' && $GLOBAL{'browser_ver'} >= 125) ||
		($GLOBAL{'browser'} eq 'KHTML' && $GLOBAL{'browser_ver'} >= 3) ||
		($GLOBAL{'browser'} eq 'IE' && $GLOBAL{'browser_ver'} >= 5)) &&
		$GLOBAL{'js_full_mode'})
		{$GLOBAL{'ajax_usable'} = 1;}

	## Can use visitor list? Disable Opera because doesn't function "unload".
	if($INI{'disp_visitor'} && $GLOBAL{'ajax_usable'} && $GLOBAL{'browser'} ne 'Opera'){$GLOBAL{'visitorlist_usable'} = 1;}

	return 1;
}


##------------------------------------------
## Decode request data
##------------------------------------------
sub decode{
	my($buffer, $name, $value, @del_num);

	if($ENV{'REQUEST_METHOD'} eq 'POST'){read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});}
	else{$buffer = $ENV{'QUERY_STRING'};}

	foreach(split(/&/, $buffer)){
		($name, $value) = split(/=/);
		$value =~ tr/+/ /;
		$value =~ s/%([\da-fA-F]{2})/chr hex($1)/ge;
		if($name =~ /_text$/){$value = &convert($value, $INI{'internal_code'}, $INI{'code'});}
		elsif($name =~ /_itext$/){$value = &convert($value, $INI{'internal_code'}, $INI{'icode'});}
		$value = &remove_xss($value);
		$value =~ s/[\t\n\r]//g;
		if($name eq 'del_num'){push(@del_num, $value);}
		$in{$name} = $value;
	}
	$in{'del_num'} = \@del_num;

	return 1;
}


##------------------------------------------
## Main routine
##------------------------------------------
sub main{
	if($in{'mode'} eq 'top'){&news($INI{'top_news'});}
	elsif($in{'mode'} eq 'set'){&set();}
	elsif($in{'mode'} eq 'regist'){&regist();}
	elsif($in{'mode'} eq 'log'){&news($INI{'log_news'});}
	elsif($in{'mode'} eq 'help'){&help();}
	elsif($in{'mode'} eq 'renew'){&modify_visitor('renew', $in{'id'});}
	elsif($in{'mode'} eq 'logout'){&modify_visitor('remove', $in{'id'});}
	elsif($in{'mode'} eq 'admin'){&admin();}
	else{&frame();}
	return 1;
}


##------------------------------------------
## Output frame
##------------------------------------------
sub frame{
	my(%dd, $output);

	foreach(@{$INI{'ip'}}){
		if(!$_){next;}
		$_ =~ s/\*/\.\*/og;
		if($ENV{'REMOTE_ADDR'} =~ /$_/){
			$output = (&skin_message())[0];
			$output =~ s/'/\\'/g;
			$output =~ s/\r//g;
			$output =~ s/\n/'+\n'/g;
			&output_http_header($INI{'camouflage_contenttype'}, $INI{'code'});
			print &convert("document.write('$output');", $INI{'code'}, $INI{'internal_code'});
			exit(0);
		}
	}

	if($COOK{'id'} ne ''){&set_cook($COOK{'name'}, $COOK{'color'}, $COOK{'stealth'}, $COOK{'jsmode'}, $COOK{'sckeydata'});}
	if($COOK{'id'} ne '' && !$COOK{'stealth'}){&modify_visitor('add', $COOK{'id'}, $COOK{'name'});}
	else{&modify_visitor('clean');}

	if($INI{'interval'} && (localtime(time))[3] ne (localtime((stat($INI{'log_file'}))[9]))[3]){unlink <$INI{'tmp_dir'}/*.tmp>;}
	if($COOK{'name'} eq ''){$dd{'name'} = $INI{'no_name_frame'};}
	else{
		$dd{'name'} = $COOK{'name'};
		$dd{'name'} =~ s/&lt;/</g;
		$dd{'name'} =~ s/&gt;/>/g;
		$dd{'name'} =~ s/&#40;/\(/g;
		$dd{'name'} =~ s/&#41;/\)/g;
		$dd{'name'} =~ s/&quot;/\"/g;
		if(length($dd{'name'}) > $INI{'len_p_name'}){$dd{'name'} = substr($dd{'name'}, 0, $INI{'len_p_name'} - 2).'...';}
		$dd{'name'} = &remove_xss($dd{'name'});
	}

	if($INI{'tmp_dir'} =~ /^\.\.(\/.*)$/){$dd{'tmp_dir'} = $INI{'scr_b'}.$1;  $dd{'tmp_dir'} =~ s/^(.*)\/.*?($1)$/$1$2/;}
	elsif($INI{'tmp_dir'} =~ /^\.(\/.*)$/){$dd{'tmp_dir'} = $INI{'scr_b'}.$1;}
	else{$dd{'tmp_dir'} = $INI{'tmp_dir'};}

	$dd{'css'} = &skin_css();
	$dd{'outframe'} = &skin_frame(\%dd);
	$dd{'outframe'} =~ s/'/\\'/g;
	$dd{'outframe'} =~ s/\r//g;
	$dd{'outframe'} =~ s/\n/'+\n'/g;
	if(!do "$INI{'js_file'}"){&debug();}
	$output = $GLOBAL{'js_full_mode'} && $COOK{'jsmode'} ? &js_full(\%dd) : &js_lite(\%dd);

	&output_http_header($INI{'camouflage_contenttype'}, $INI{'code'});  ## Auto insert of ad-tag is evaded by the Content-type camouflage.
	print &convert($output, $INI{'code'}, $INI{'internal_code'});

	return 1;
}


##------------------------------------------
## Output HTTP header
##------------------------------------------
sub output_http_header{
	my($con_type, $code) = @_;

	$code = $code eq 'sjis' ? 'Shift_JIS' : $code eq 'euc' ? 'EUC-JP' : $code eq 'jis' ? 'ISO-2022-JP' : $code eq 'utf8' ? 'UTF-8' : $code;
	print "Content-type: $con_type; charset=$code\n";
	if($INI{'gzip'} && $ENV{'HTTP_ACCEPT_ENCODING'} =~ /gzip/ && $INI{'gzip_pass'} ne ''){
		if($ENV{'HTTP_ACCEPT_ENCODING'} =~ /x-gzip/){print "Content-encoding: x-gzip\n\n";}
		else{print "Content-encoding: gzip\n\n";}
		open(STDOUT, "| $INI{'gzip_pass'} -1 -c");
	}
	else{print "\n";}

	return 1;
}


##------------------------------------------
## HTML header of internal inline-frame
##------------------------------------------
sub head{
	if(!$GLOBAL{'head_flag'}){
		my %dd;
		$dd{'page_id'} = shift;
		$dd{'code'} = $INI{'icode'} eq 'sjis' ? 'Shift_JIS' : $INI{'icode'} eq 'euc' ? 'EUC-JP' : $INI{'icode'} eq 'jis' ? 'ISO-2022-JP' : $INI{'icode'} eq 'utf8' ? 'UTF-8' : $INI{'icode'};
		$dd{'visibility'} = $GLOBAL{'js_full_mode'} && $COOK{'jsmode'} ? 'hidden' : 'visible';
		$dd{'css'} = &skin_css2(\%dd);
		($dd{'title'} = $INI{'title'}) =~ s/<.*>//g;

		&output_http_header('text/html', $INI{'icode'});
		$GLOBAL{'head_flag'} = 1;

		return &skin_head(\%dd);
	}
	else{return undef;}
}


##------------------------------------------
## News
##------------------------------------------
sub news{
	my $num = shift;
	my($line, %dd, @news, $page_id);

	open(LOGR, "$INI{'log_file'}") || &error((&skin_message())[1]);
	foreach(1..$num){
		$dd{'num'} = $_;  $line = <LOGR>;
		if($line eq ''){last;}
		($dd{'name'}, $dd{'date'}, $dd{'color'}, $dd{'com'}, undef) = split(/\t/, $line);
		unshift(@news, &skin_line(\%dd));
	}
	close(LOGR);

	$dd{'news'} = join('', @news);
	$page_id = $in{'mode'} eq 'log' ? 'log' : 'news';
	print &convert(&head($page_id).&skin_news(\%dd), $INI{'icode'}, $INI{'internal_code'});

	return 1;
}


##------------------------------------------
## Set form
##------------------------------------------
sub set{
	if(!$in{'action'}){
		my(%dd, %sc);
		my $i = 0;
		my @jsmode = ('Lite Mode', 'Full Mode');
		my @mcode = (0..7);
		my @mkey = ('', 'Alt', 'Shift', 'Alt+Shift', 'Ctrl', 'Alt+Ctrl', 'Shift+Ctrl', 'Alt+Shift+Ctrl');
		my @sccode = (48..57, 65..90, 37..40);
		my @sckey = ('0'..'9', 'A'..'Z', '&larr;', '&uarr;', '&rarr;', '&darr;');

		foreach(@{$INI{'color'}}){
			($dd{'print'}, $dd{'value'}) = split(/:/);
			$dd{'color'} = $dd{'value'};
			$dd{'selected'} = $dd{'value'} eq $COOK{'color'} ? ' selected="selected"' : '';
			$dd{'color_list'} .= &skin_set_select(\%dd);
		}

		$dd{'display'}{'visitorlist_usable'} = $GLOBAL{'visitorlist_usable'} ? 'block' : 'none';
		if($COOK{'stealth'} && $GLOBAL{'visitorlist_usable'}){$dd{'stealth_checked'} = ' checked="checked"';}

		if($GLOBAL{'js_full_mode'}){
			$dd{'display'}{'js_full_mode'} = 'block';

			for($i=$#jsmode; $i>=0; $i--){
				$dd{'value'} = $i;
				$dd{'print'} = $jsmode[$i];
				$dd{'color'} = '000000';
				$dd{'selected'} = $dd{'value'} eq $COOK{'jsmode'} ? ' selected="selected"' : '';
				$dd{'jsmode_list'} .= &skin_set_select(\%dd);
			}

			$i = 0;
			foreach(split(/:/,$COOK{'sckeydata'})){
				$sc{'m'}[$i] = substr($_,0,1);
				$sc{'k'}[$i] = substr($_,1);
				$i++;
			}
			foreach $i(0..11){
				foreach(0..$#mcode){
					$dd{'value'} = $mcode[$_];
					$dd{'print'} = $mkey[$_];
					$dd{'color'} = '000000';
					$dd{'selected'} = $dd{'value'} eq $sc{'m'}[$i] ? ' selected="selected"' : '';
					$dd{'mkey_list'}[$i] .= &skin_set_select(\%dd);
				}
				foreach(0..$#sccode){
					$dd{'value'} = $sccode[$_];
					$dd{'print'} = $sckey[$_];
					$dd{'color'} = '000000';
					$dd{'selected'} = $dd{'value'} eq $sc{'k'}[$i] ? ' selected="selected"' : '';
					$dd{'sckey_list'}[$i] .= &skin_set_select(\%dd);
				}
			}
		}
		else{$dd{'display'}{'js_full_mode'} = 'none';}

		print &convert(&head('set').&skin_set(\%dd), $INI{'icode'}, $INI{'internal_code'});
	}
	else{
		my @sclist = ('focus', 'mini', 'close', 'left', 'up', 'right', 'down', 'big', 'small', 'reset', 'news', 'list');
		my $sckeydata;

		if($ENV{'REQUEST_METHOD'} ne 'POST'){&error((&skin_message())[2]);}
		my $count = ($in{'name_itext'} =~ s/&lt;/&lt;/g) * 3;
		$count += ($in{'name_itext'} =~ s/&gt;/&gt;/g) * 3;
		$count += ($in{'name_itext'} =~ s/&#40;/&#40;/g) * 4;
		$count += ($in{'name_itext'} =~ s/&#41;/&#41;/g) * 4;
		$count += ($in{'name_itext'} =~ s/&quot;/&quot;/g) * 5;
		if(length($in{'name_itext'}) - $count > $INI{'len_name'}){&error((&skin_message())[3]);}
		foreach(@sclist){$sckeydata .= $in{"sc_m_$_"}.$in{"sc_k_$_"}.':';}
		chop $sckeydata;

		&set_cook($in{'name_itext'}, $in{'color'}, $in{'stealth'}, $in{'jsmode'}, $sckeydata);
		if((!$in{'stealth'} && $COOK{'stealth'}) || ($in{'name_itext'} && !$COOK{'name'})){&modify_visitor('add', $COOK{'id'}, $in{'name_itext'});}
		elsif(($in{'stealth'} && !$COOK{'stealth'}) || (!$in{'name_itext'} && $COOK{'name'})){&modify_visitor('remove', $COOK{'id'});}
		elsif(!$in{'stealth'} && !$COOK{'stealth'}){&modify_visitor('modify', $COOK{'id'}, $in{'name_itext'});}

		&news($INI{'top_news'});
	}

	return 1;
}


##------------------------------------------
## Help
##------------------------------------------
sub help{
	my(%dd, %sckey);
	my $i = 0;
	my @mkey = ('', 'Alt + ', 'Shift + ', 'Alt + Shift + ', 'Ctrl + ', 'Alt + Ctrl + ', 'Shift + Ctrl + ', 'Alt + Shift + Ctrl + ');
	my @sccode = (48..57, 65..90, 37..40);
	my @sckey = ('0'..'9', 'A'..'Z', '&larr;', '&uarr;', '&rarr;', '&darr;');

	$dd{'name'} = $COOK{'name'} eq '' ? $INI{'no_name_frame'} : $COOK{'name'};
	if(length($dd{'name'}) > $INI{'len_p_name'}){$dd{'name'} = substr($dd{'name'}, 0, $INI{'len_p_name'} - 2).'...';}
	$dd{'autoreload_news'} = $INI{'realtime_reload'} && $GLOBAL{'ajax_usable'} ? 'block' : 'none';
	$dd{'display'}{'visitorlist_usable'} = $INI{'disp_visitor'} && $GLOBAL{'ajax_usable'} ? 'block' : 'none';
	$dd{'display'}{'visitorlist_reload_time'} = $INI{'visitorlist_reload_time'} && $GLOBAL{'visitorlist_usable'} ? 'block' : 'none';
	$dd{'display'}{'js_full_mode'} = $GLOBAL{'js_full_mode'} ? 'block' : 'none';
	foreach(0..$#sccode){$sckey{$sccode[$_]} = $sckey[$_];}
	foreach(split(/:/, $COOK{'sckeydata'})){$dd{'sc'}[$i] = $mkey[substr($_, 0, 1)].$sckey{substr($_, 1)};  $i++;}

	print &convert(&head('help').&skin_help(\%dd), $INI{'icode'}, $INI{'internal_code'});

	return 1;
}


##------------------------------------------
## Character-code conversion
##------------------------------------------
sub convert{
	my($value, $code, $incode) = @_;
	if($code eq $incode){return $value;}
	elsif(!$INI{'use_Jcode'} && $GLOBAL{'code_flag'} != 2 &&
				($code eq 'sjis' || $code eq 'euc' || $code eq 'jis') &&
				($incode eq 'sjis' || $incode eq 'euc' || $incode eq 'jis')){
		$GLOBAL{'code_flag'} = 1;
		require $INI{'jcode'};
		&jcode::convert(\$value, $code, $incode);
	}
	else{
		$GLOBAL{'code_flag'} = 2;
		if(!do './exlib.pl'){&debug();}
		Jcode::convert(\$value, $code, $incode);
	}
	return $value;
}


##------------------------------------------
## Writing routine
##------------------------------------------
sub regist{
	if($in{'com_text'} ne ''){
		my($id, $name, $date, @news, $i, $line);

		$id = $COOK{'id'} eq '' ? 'nothing_id' : $COOK{'id'};
		if($ENV{'REQUEST_METHOD'} ne "POST"){&error((&skin_message())[2]);}
		if($INI{'interval'} && -e "$INI{'tmp_dir'}/$id.tmp" && (stat("$INI{'tmp_dir'}/$id.tmp"))[9] > time - $INI{'interval'}){&error((&skin_message())[4]);}
		if(length($in{'com_text'}) > $INI{'len_com'}){&error((&skin_message())[5]);}
		if(length($COOK{'name'}) > $INI{'len_name'}){&error((&skin_message())[3]);}
		$name = $COOK{'name'} eq '' ? $INI{'no_name'} : $COOK{'name'};
		$date = &get_time();
		if($INI{'autolink'}){$in{'com_text'} = &autolink($in{'com_text'});}
		$news[0] = "$name\t$date\t$COOK{'color'}\t$in{'com_text'}\t$ENV{'REMOTE_ADDR'}\n";

		&lock();
		open(LOGR, "$INI{'log_file'}") || &error((&skin_message())[1]);
		for($i=1; $i<$INI{'log_news'}; $i++){$line = <LOGR>;  push(@news, $line);}
		close(LOGR);

		open(LOGW, "> $INI{'log_file'}") || &error((&skin_message())[6]);
		print LOGW @news;
		close(LOGW);
		&unlock();

		if($INI{'realtime_reload'}){
			open(STAMP, "> $INI{'tmp_dir'}/$INI{'log_timestamp_file'}") || &error((&skin_message())[12]);
			print STAMP time;
			close(STAMP);
		}
		if($INI{'interval'}){
			open(ID, "> $INI{'tmp_dir'}/$id.tmp") || &error((&skin_message())[11]);
			close(ID);
		}
	}
	&news($INI{'top_news'});
	return $in{'com_text'} eq '' ? 0 : 1;
}


##------------------------------------------
## Changing visitor list
##------------------------------------------
sub modify_visitor{
	my($action, $id, $name) = @_;
	my($log_id, $log_name, $log_date, $stamp_flag, $add_flag, @new_log);

	if(!$GLOBAL{'visitorlist_usable'} || (!$COOK{'jsmode'} && $action ne 'remove')){return 0;}
	my $date = time;
	$name = &convert($name, 'utf8', $INI{'internal_code'});

	open(MEMBER, "$INI{'tmp_dir'}/$INI{'visitorlist_filename'}");
	while(<MEMBER>){
		chomp;
		if($_ eq 'no data'){next;}
		($log_name, $log_id, $log_date) = split(/\t/);

		if($log_id eq $id){
			if($action eq 'add'){$log_date = $date;  $add_flag = 1;}
			elsif($action eq 'remove'){$stamp_flag = 1;  next;}
			elsif($action eq 'modify'){
				if($log_name ne $name){$stamp_flag = 1;}
				($log_name, $log_id, $log_date) = ($name, $id, $date);
			}
			elsif($action eq 'renew'){$log_date = $date;}
		}
		elsif($date - $log_date > $INI{'visitor_timeout'}){$stamp_flag = 1;  next;}

		push(@new_log, "$log_name\t$log_id\t$log_date\n");
	}
	if($action eq 'add' && !$add_flag){push(@new_log, "$name\t$id\t$date\n");  $stamp_flag = 1;}
	close(MEMBER);

	if($action eq 'clean' && !$stamp_flag){return 0;}
	if($new_log[0] eq ''){$new_log[0] = 'no data';}
	open(MEMBER, "> $INI{'tmp_dir'}/$INI{'visitorlist_filename'}");
	print MEMBER join("", @new_log);
	close(MEMBER);

	if($INI{'visitorlist_reload_time'} && $stamp_flag){
		open(STAMP, "> $INI{'tmp_dir'}/$INI{'visitorlist_timestamp_file'}");
		print STAMP time;
		close(STAMP);
	}

	return 1;
}


##------------------------------------------
## Get time
##------------------------------------------
sub get_time{
	$ENV{'TZ'} = 'JST-9';
	my @week = ('Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat');
	my($sec, $min, $hour, $mday, $mon, $year, $wday) = localtime(time);
	return sprintf("%04d/%02d/%02d(%s) %02d:%02d:%02d", $year+1900, $mon+1, $mday, $week[$wday], $hour, $min, $sec);
}


##------------------------------------------
## The browser name and version get according to engine
##------------------------------------------
sub get_browser{
	if($ENV{'HTTP_USER_AGENT'} =~ /(DoCoMo|UP\.Browser|J-PHONE|Vodafone|MOT|KYOCERA|DDIPOCKET)/){return('MOBILE', undef);}
	elsif($ENV{'HTTP_USER_AGENT'} =~ /Opera.([\d\.]+)/){return('Opera', $1);}
	elsif($ENV{'HTTP_USER_AGENT'} =~ /MSIE ([\d\.]+)/){return('IE', $1);}
	elsif($ENV{'HTTP_USER_AGENT'} =~ /AppleWebKit\/([\d\.]+)/){return('AppleWebKit', $1);}  ## Safari
	elsif($ENV{'HTTP_USER_AGENT'} =~ /KHTML|Konqueror/){
		if($ENV{'HTTP_USER_AGENT'} =~ /Konqueror\/([\d\.]+)/){return('KHTML', $1);}  ## Konqueror
		elsif($ENV{'HTTP_USER_AGENT'} =~ /KHTML\/([\d\.]+)/){return('KHTML', $1);}  ## KHTML
		else{return('KHTML', 0);}
	}
	elsif($ENV{'HTTP_USER_AGENT'} =~ /Gecko/){
		if($ENV{'HTTP_USER_AGENT'} =~ /rv:([\d\.]+)/){return('Gecko', $1);}  ## Netscape 6~ , Mozilla , Firefox
		else{return('Gecko', 0);}
	}
	elsif($ENV{'HTTP_USER_AGENT'} =~ m|Mozilla/([\d\.]+)|){return('Netscape', $1);}  ## Netscape 1~4
	else{return('Unknown', undef);}
}


##------------------------------------------
## Auto Link
##------------------------------------------
sub autolink{
	my $value = shift;
	my %dd;
	my $auto_link_f = sub{
		my($url, $mark, $anchor, $result) = @_;
		if($url =~ /$INI{'url_filter'}/io){
			$dd{'url'} = "$url";
			($result = (&skin_message(\%dd))[13].$mark.$anchor) =~ s/[\t\n\r]//g;
		}
		elsif($mark){
			$dd{'url'} = "$url$mark$anchor";
			($result = &skin_autolink(\%dd)) =~ s/[\t\n\r]//g;
		}
		else{
			$dd{'url'} = "$url";
			($result = &skin_autolink(\%dd).$anchor) =~ s/[\t\n\r]//g;
		}
		return $result;
	};
	$value =~ s{((?:https?|shttp|ftp)://[\w\/\.\%\~\!\$\&\-\:\;\=\@]+)([#\?]?)([^\ \@\<]*)}{$auto_link_f->($1, $2, $3)}eg;
	return $value;
}


##------------------------------------------
## File Lock
##------------------------------------------
sub lock{
	my $retry = 3;
	my $lock_type = $INI{'lock_type'};

	if($lock_type == 3){
		eval{symlink('', '');};
		if($@){$lock_type = 2;}
		else{$lock_type = 1;}
	}
	if(-e "$INI{'tmp_dir'}/$INI{'lock_filename'}" && (stat("$INI{'tmp_dir'}/$INI{'lock_filename'}"))[9] < time - 60){&unlock();}

	if($lock_type == 1){
		while(!eval{symlink('.', "$INI{'tmp_dir'}/$INI{'lock_filename'}");}){
			if(--$retry <= 0){&error((&skin_message())[7]);}
			sleep(1);
		}
	}
	elsif($lock_type == 2){
		while(!mkdir("$INI{'tmp_dir'}/$INI{'lock_filename'}", 0705)){
			if(--$retry <= 0){&error((&skin_message())[7]);}
			sleep(1);
		}
	}

	$GLOBAL{'lock_flag'} = $lock_type;
	return $lock_type;
}


##------------------------------------------
## Remove File Lock
##------------------------------------------
sub unlock{
	if($GLOBAL{'lock_flag'}){
		if($GLOBAL{'lock_flag'} == 1){unlink("$INI{'tmp_dir'}/$INI{'lock_filename'}");}
		elsif($GLOBAL{'lock_flag'} == 2){rmdir("$INI{'tmp_dir'}/$INI{'lock_filename'}");}
		$GLOBAL{'lock_flag'} = 0;
		return 1;
	}
	else{return 0;}
}


##------------------------------------------
## Get Cookie
##------------------------------------------
sub get_cook{
	my($key, $val, %ck);
	foreach(split(/;/, $ENV{'HTTP_COOKIE'})){
		($key, $val) = split(/=/);
		$key =~ s/\s//g;
		$ck{$key} = $val;
	}
	foreach(split(/<::>/, $ck{'RCSBBS3'})){
		($key, $val) = split(/<>/);
		$val =~ tr/+/ /;
		$val =~ s/%([\da-fA-F]{2})/chr hex($1)/ge;
		$val = &remove_xss($val);
		$val =~ s/[\t\n\r]//g;
		$COOK{$key} = $val;
	}

	if($COOK{'color'} eq '' || $COOK{'color'} =~ /\W/){$COOK{'color'} = $INI{'color'}[0];  $COOK{'color'} =~ s/^.*:(.*)$/$1/;}
	if($COOK{'id'} =~ /\W/){$COOK{'id'} = '';}
	if($COOK{'stealth'} ne '0' && $COOK{'stealth'} ne '1'){$COOK{'stealth'} = '0';}
	if($COOK{'jsmode'} eq '' || $COOK{'jsmode'} =~ /\W/){$COOK{'jsmode'} = '1';}
	if($COOK{'sckeydata'} eq '' || $COOK{'sckeydata'} =~ /[^\d\:]/){$COOK{'sckeydata'} = $INI{'default_sckeydata'};}

	return 1;
}


##------------------------------------------
## Cookie Register
##------------------------------------------
sub set_cook{
	my($name, $color, $stealth, $jsmode, $sckeydata) = @_;
	my @t = gmtime(time + 180*24*60*60);
	my @m = ('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec');
	my @w = ('Sun', 'Mon', 'Tue', 'Wed',' Thu', 'Fri', 'Sat');
	my $gmt = sprintf("%s,%02d-%s-%04d %02d:%02d:%02d GMT", $w[$t[6]], $t[3], $m[$t[4]], $t[5]+1900, $t[2], $t[1], $t[0]);

	$name =~ s/([^a-zA-Z0-9_.-])/uc sprintf("%%%02x", ord($1))/eg;
	if($color =~ /\W/){$color = $INI{'color'}[0];  $color =~ s/^.*:(.*)$/$1/;}
	if($COOK{'id'} =~ /\W/){$COOK{'id'} = '';}
	if($COOK{'id'} eq ''){
		my @word = ('0'..'9', 'a'..'z', 'A'..'Z');
		srand;
		foreach(1..20){$COOK{'id'} .= $word[int(rand(@word))];}
	}
	if($stealth ne '0' && $stealth ne '1'){$stealth = '0';}
	if($jsmode eq '' || $jsmode =~ /\W/){$jsmode = '1';}
	if($sckeydata =~ /[^\d\:]/){$sckeydata = '';}

	print "Set-Cookie: RCSBBS3=name<>$name<::>color<>$color<::>id<>$COOK{'id'}<::>stealth<>$stealth<::>jsmode<>$jsmode<::>sckeydata<>$sckeydata; expires=$gmt;\n";

	return 1;
}


##------------------------------------------
## Remove XSS
##------------------------------------------
sub remove_xss{
	my $value = shift;
	$value =~ s/</&lt;/g;
	$value =~ s/>/&gt;/g;
	$value =~ s/\(/&#40;/g;
	$value =~ s/\)/&#41;/g;
	$value =~ s/"/&quot;/g;
	return $value;
}


##------------------------------------------
## Error routine
##------------------------------------------
sub error{
	my %dd;
	$dd{'error_mess'} = shift;
	&unlock();
	print &convert(&head('error').&skin_error(\%dd), $INI{'icode'}, $INI{'internal_code'});
	exit(0);
}


##------------------------------------------
## Simple debugger
##------------------------------------------
sub debug{
	$@ =~ s/&/&amp;/g;
	$@ =~ s/'/\\'/g;
	$@ =~ remove_xss($@);
	$@ =~ s/\n/<br \/>/g;
	print "Content-type: unknown/javascript\n\ndocument.write('<p>RCS-BOARD:ERROR!!</p><p>$@</p>');";
	exit(0);
}


##------------------------------------------
## Administrator mode
##------------------------------------------
sub admin{
	my(@output, $num, $flag, @news, %dd);

	if($in{'admin_pass'} && $ENV{'REQUEST_METHOD'} ne "POST"){&error((&skin_message())[2]);}
	elsif($in{'admin_pass'} && $INI{'admin_pass'} eq $in{'admin_pass'}){
		if(!$in{'action'}){
			open(LOGR, "$INI{'log_file'}") || &error((&skin_message())[1]);
			while(<LOGR>){
				chomp;
				$dd{'num'}++;
				($dd{'name'}, $dd{'date'}, $dd{'color'}, $dd{'com'}, $dd{'ip'}) = split(/\t/);
				unshift(@output, &skin_admin_line(\%dd));
			}
			close(LOGR);
			$dd{'news'} = join("", @output);
			print &convert(&head('admindel').&skin_admin(\%dd), $INI{'icode'}, $INI{'internal_code'});
		}
		elsif($in{'action'} eq 'del'){
			open(LOGR, "$INI{'log_file'}") || &error((&skin_message())[1]);
			while(<LOGR>){
				$num++;
				foreach(@{$in{'del_num'}}){
					if($num == $_){
						$flag = 1;
						$dd{'del_num'}++;
						last;
					}
				}
				if($flag){$flag = 0;  next;}
				push(@news, $_);
			}
			close(LOGR);

			open(LOGW, "> $INI{'log_file'}") || &error((&skin_message())[6]);
			print LOGW @news;
			close(LOGW);
			$dd{'mess'} = $dd{'del_num'} ? (&skin_message(\%dd))[8] : (&skin_message())[9];
			print &convert(&head('admindelfin').&skin_admin_fin(\%dd), $INI{'icode'}, $INI{'internal_code'});
		}
	}
	elsif($in{'admin_pass'} && $INI{'admin_pass'} ne $in{'admin_pass'}){&error((&skin_message())[10]);}
	else{print &convert(&head('login').&skin_login(), $INI{'icode'}, $INI{'internal_code'});}
	return 1;
}


__END__
